/*
 * CollabNet TeamForge(r)
 * Copyright 2013 CollabNet, Inc.  All rights reserved.
 * http://www.collab.net
 */
 /*
        Take the value of Effort field (estimated/actual/remaining), divide it by the scalling factor and format it to 2 decimal places.
        Eg.
        3 base units = 1 rock
        We have 2 base units
        Change it to rocks
        Need to display 0.67 rocks
        So, 2 base units
        Multiply this by 100, so it is 200
        Divide by 3, so it is 66.666666666666
        Round it, so it is 67
        Divide by 100, so it is 0.67
        */
  function estimatedEffortComboChange() {
     $j('#estimatedEff').val(Math.round(100 * parseFloat($j('#estimatedEffort').val()) / getScallingFactor($j('#estimatedEffortUnit').val())) / 100);
  }
  
  function estimatedEffortInputChange() {
    if (!isNaN($j('#estimatedEff').val())) {
      var r = Math.round(parseFloat($j('#estimatedEff').val()) * getScallingFactor($j('#estimatedEffortUnit').val()));
      $j('#estimatedEffort').val(r);
    } else {
        $j('#estimatedEffort').val("-1");
    }
  }
  
  function remainingEffortComboChange() {
     $j('#remainingEff').val(Math.round(100 * parseFloat($j('#remainingEffort').val()) / getScallingFactor($j('#remainingEffortUnit').val())) / 100);
  }
	  
  function remainingEffortInputChange() {
    if (!isNaN($j('#remainingEff').val())) {
      var r = Math.round(parseFloat($j('#remainingEff').val()) * getScallingFactor($j('#remainingEffortUnit').val()));
      $j('#remainingEffort').val(r);
    } else {
        $j('#remainingEffort').val("-1");
    }
  }
  function actualEffortComboChange() {
    $j('#actualEff').val(Math.round(100 * parseFloat($j('#actualEffort').val()) / getScallingFactor($j('#actualEffortUnit').val())) / 100);
  }

  function actualEffortInputChange() {
    if (!isNaN($j('#actualEff').val())) {
      var r = Math.round(parseFloat($j('#actualEff').val()) * getScallingFactor($j('#actualEffortUnit').val()));
      $j('#actualEffort').val(r);
    } else {
      $j('#actualEffort').val("-1");
    }
  }
  
  function displayIfTransitionRequiredField(currentStatus, fieldId, statusChanged) {
  	currentStatus = this.escapeHtml(currentStatus);
        var reqFieldsForCurrentStatus = statusToFieldsMap[currentStatus];
        var reqFieldMark = document.getElementById('trf_' + fieldId);
       
        if (reqFieldMark != null) {
          
      	  if(reqFieldsForCurrentStatus[fieldId]){ // if it is found int he reqFieldsForCurrentStatus array
            // make it appear - change color instead of making the span disappear to prevent shifting          
            reqFieldMark.style.color = "#cc3300"; // make it appear
            reqFieldMark.style.backgroundColor = "0 none"; // make it appear
            reqFieldCount++;
          } else {
            // make it disappear
            reqFieldMark.style.color = "transparent"; // make it disappear
            reqFieldMark.style.backgroundColor = "0 none"; // make it disappear
          }
        }
        var reqFieldError = document.getElementById('err_' + fieldId);
        if (reqFieldError != null) {
          if (statusChanged != 'true') {
            // make it appear - change color instead of making the span disappear to prevent shifting
            reqFieldError.style.display = "";
          } else { //error message doesn't need to be displayed
            // make it disappear
            reqFieldError.style.display = "none";
          }
        }
      }

  function escapeHtml(unsafe) {
      return unsafe
           .replace(/"/g, "&#034;")
           .replace(/'/g, "&#039;");
   }
